---
title: Offical data to R without Excel
author: Gregor
date: '2022-12-20'
slug: surs-api
categories: ["basic"]
tags: ["R", "API", "library"]
---

<script src="{{< blogdown/postref >}}index_files/htmlwidgets/htmlwidgets.js"></script>
<link href="{{< blogdown/postref >}}index_files/datatables-css/datatables-crosstalk.css" rel="stylesheet" />
<script src="{{< blogdown/postref >}}index_files/datatables-binding/datatables.js"></script>
<script src="{{< blogdown/postref >}}index_files/jquery/jquery-3.6.0.min.js"></script>
<link href="{{< blogdown/postref >}}index_files/dt-core/css/jquery.dataTables.min.css" rel="stylesheet" />
<link href="{{< blogdown/postref >}}index_files/dt-core/css/jquery.dataTables.extra.css" rel="stylesheet" />
<script src="{{< blogdown/postref >}}index_files/dt-core/js/jquery.dataTables.min.js"></script>
<link href="{{< blogdown/postref >}}index_files/crosstalk/css/crosstalk.min.css" rel="stylesheet" />
<script src="{{< blogdown/postref >}}index_files/crosstalk/js/crosstalk.min.js"></script>


<p><em>Hey there! API calls are pretty common these days, and you’d expect that government offices have them all sorted out. Lucky us, today, we can to talk about how to connect to the Statistical Office of the Republic of Slovenia (SURS) database via an API call.</em></p>
<div id="a-little-bit-about-pxweb-api" class="section level1">
<h1>A little bit about PXWEB API</h1>
<p>The SURS team was nice enough to use PXWEB, which is an API structure developed by Statistics Sweden and other national statistical institutions (NSIs) to disseminate public statistics in a structured way. This API allows you to download and use data from statistical agencies without using a web browser, directly over HTTP/HTTPS. You can see which other statistical offices use the same API structure <a href="https://www.scb.se/en/services/statistical-programs-for-px-files/px-web/pxweb-examples/">here</a>,</p>
<blockquote>
<p>I won’t go too in-depth into the whole package, called <a href="https://cran.r-project.org/web/packages/pxweb/vignettes/pxweb.html">pxweb</a>. Instead, I’ll just present my use case.</p>
</blockquote>
</div>
<div id="selecting-the-data" class="section level1">
<h1>Selecting the data</h1>
<p>So you have a dataset that you find on the SURS website and you want to use it in your own analysis. For our case, we used something current: the amount of electricity produced in Slovenia in previous months. You can play with the data <a href="https://pxweb.stat.si/SiStatData/pxweb/sl/Data/-/1817601S.px">here</a></p>
<p>After you select the data you want to see, you have a tab called <strong>About table</strong> where you’ll find a bucket <em>API query for that table</em>. When you click on it, you’ll find an API URL and a JSON query. The first part (the URL) needs to be copied into our R script, and we only need to quickly go through the query. We need to remember the names of the variables in this dataset.</p>
</div>
<div id="some-coding" class="section level1">
<h1>Some coding</h1>
<pre class="r"><code>#install.packages(&quot;pxweb&quot;)
# useful tip, in case of using ščćđ
#Sys.setlocale(locale=&quot;UTF-8&quot;) 

# our library
library(pxweb)

api_dataset &lt;-
  &quot;https://pxweb.stat.si:443/SiStatData/api/v1/en/Data/1817601S.px&quot;
  

px_api_call &lt;- pxweb_get(api_dataset)
# here we calling this URL request, that we get in previous chapther.</code></pre>
<p>Ok, now we’ve saved our API call. Now we need to add a query to specify what kind of data we want. Our variables are <em>MERITVE</em> in <em>MESEC</em>. Now you have two options. You can specify in detail what kind of data you want, or you can download all of the data and then use some data manipulation to remove the parts you don’t need.</p>
<blockquote>
<p>If you look carefully at the URL link, you’ll notice that it contains “en”. If you want English-named variables in your data, you can use this setting, but you can change it to “sl” (right in the URL) to get Slovenian names instead. However, be careful to use Slovenian names for the variables you use in your query.</p>
</blockquote>
<pre class="r"><code>query_list &lt;- 
  list(&quot;MERITVE&quot;=c(&quot;*&quot;), # Use &quot;*&quot; to select all
       &quot;MESEC&quot;=c(&quot;*&quot;))

px_query &lt;- pxweb_query(query_list)
#translate into px syntax</code></pre>
<p>Now, you can validate your query, and if you don’t have any errors, you are ready to go.</p>
<pre class="r"><code># if you don&#39;t get an error, it seems good to go.
pxweb_validate_query_with_metadata(px_query, px_api_call)</code></pre>
<p>Now you can execute the query with function <code>pxweb_get</code> and transform to data.frame or any other data frame you like.</p>
<pre class="r"><code>data_px_api &lt;- pxweb_get(url = api_dataset,query = px_query)

final_data &lt;- as.data.frame(data_px_api, 
                            column.name.type = &quot;text&quot;, 
                            variable.value.type = &quot;text&quot;)</code></pre>
<p>And here it is, our data are here:</p>
<div class="datatables html-widget html-fill-item-overflow-hidden html-fill-item" id="htmlwidget-1" style="width:100%;height:auto;"></div>
<script type="application/json" data-for="htmlwidget-1">{"x":{"filter":"none","vertical":false,"data":[["Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total","Gross production - Total"],["2022M11 (provisional data)","2022M10 (provisional data)","2022M09 (provisional data)","2022M08","2022M07","2022M06","2022M05","2022M04","2022M03","2022M02","2022M01","2021M12","2021M11","2021M10","2021M09","2021M08","2021M07","2021M06","2021M05","2021M04","2021M03","2021M02","2021M01","2020M12","2020M11","2020M10","2020M09","2020M08","2020M07","2020M06","2020M05","2020M04","2020M03","2020M02","2020M01","2019M12","2019M11","2019M10","2019M09","2019M08","2019M07","2019M06","2019M05","2019M04","2019M03","2019M02","2019M01","2018M12","2018M11","2018M10","2018M09","2018M08","2018M07","2018M06","2018M05","2018M04","2018M03","2018M02","2018M01","2017M12","2017M11","2017M10","2017M09","2017M08","2017M07","2017M06","2017M05","2017M04","2017M03","2017M02","2017M01","2016M12","2016M11","2016M10","2016M09","2016M08","2016M07","2016M06","2016M05","2016M04","2016M03","2016M02","2016M01","2015M12","2015M11","2015M10","2015M09","2015M08","2015M07","2015M06","2015M05","2015M04","2015M03","2015M02","2015M01","2014M12","2014M11","2014M10","2014M09","2014M08","2014M07","2014M06","2014M05","2014M04","2014M03","2014M02","2014M01","2013M12","2013M11","2013M10","2013M09","2013M08","2013M07","2013M06","2013M05","2013M04","2013M03","2013M02","2013M01","2012M12","2012M11","2012M10","2012M09","2012M08","2012M07","2012M06","2012M05","2012M04","2012M03","2012M02","2012M01","2011M12","2011M11","2011M10","2011M09","2011M08","2011M07","2011M06","2011M05","2011M04","2011M03","2011M02","2011M01","2010M12","2010M11","2010M10","2010M09","2010M08","2010M07","2010M06","2010M05","2010M04","2010M03","2010M02","2010M01","2009M12","2009M11","2009M10","2009M09","2009M08","2009M07","2009M06","2009M05","2009M04","2009M03","2009M02","2009M01","2008M12","2008M11","2008M10","2008M09","2008M08","2008M07","2008M06","2008M05","2008M04","2008M03","2008M02","2008M01","2007M12","2007M11","2007M10","2007M09","2007M08","2007M07","2007M06","2007M05","2007M04","2007M03","2007M02","2007M01","2006M12","2006M11","2006M10","2006M09","2006M08","2006M07","2006M06","2006M05","2006M04","2006M03","2006M02","2006M01","2005M12","2005M11","2005M10","2005M09","2005M08","2005M07","2005M06","2005M05","2005M04","2005M03","2005M02","2005M01","2004M12","2004M11","2004M10","2004M09","2004M08","2004M07","2004M06","2004M05","2004M04","2004M03","2004M02","2004M01"],[803.267,553.095,1076.438,1079.178,1089.279,1176.977,1230.371,1160.792,1313.725,1120.05,1305.958,1330.631,1327.768,1230.989,1117.606,1408.349,1230.024,1338.514,1428.518,805.776,1411.117,1377.951,1514.313,1547.669,1497.783,1828.836,1470.476,1437.443,1529.232,1447.488,1292.864,1157.325,1242.603,1155.18,1295.305,1552.652,1605.338,884.691,1090.924,1218.541,1431.043,1492.822,1466.81,1276.289,1230.151,1280.031,1277.295,1243.016,1566.096,1406.974,1342.436,1336.377,1330.407,1234.558,1388.206,1069.325,1509.044,1307.401,1431.186,1451.219,1361.019,1319.686,1442.461,1387.432,1389.67,1226.177,1347.103,1200.512,1403.858,1244.965,1414.502,1478,1397,948,1314,1415,1556,1515,1396,1317,1427,1304,1317,1262,1284,1458,1341,1268,1409,1342,977,904,1286,1161,1355,1371,1410,1302,1415,1388,1391,1400,1540,1437,1571,1430,1579,1454,1194,927,1315,1308,1465,1448,1453,1388,1415,1210,1405,1463,1575,1508,1400,1351,1423,1309,863,967,1218,1247,1291,1314,1348,1347,1308,1317,1257,1318,1322,1351,1320,1272,1518,1607,1488,1003,1405,1308,1252,1371,1440,1288,1467,1244,1453,1460,1393,1397,1282,1215,1524,1468,1422,1003,1409,1328,1412,1439,1381,1332,1298,1321,1456,1414,1387,1404,1318,1269,1368,1353,1205,932,1297,1289,1401,1122,1130,1303,1438,1230,1340,1290,1291,1328,1219,1260,1325,1406,1256,965,1318,1171,1266,1252,1327,1412,1220,1148,1278,1218,1243,1265,1247,1205,1304,1311,1387,1332,895,1157,1359,1336,1378,1334,1350,1224,1327]],"container":"<table class=\"display\">\n  <thead>\n    <tr>\n      <th>MEASURES<\/th>\n      <th>MONTH<\/th>\n      <th>Electricity (GWh)<\/th>\n    <\/tr>\n  <\/thead>\n<\/table>","options":{"columnDefs":[{"className":"dt-right","targets":2}],"order":[],"autoWidth":false,"orderClasses":false}},"evals":[],"jsHooks":[]}</script>
<p>Ok, we can visualize a little bit</p>
<p><img src="{{< blogdown/postref >}}index_files/figure-html/unnamed-chunk-6-1.png" width="672" /></p>
</div>
